<%@ Language=VBScript %>
<%
    option explicit
    dim MyDate
    dim MyTime
    dim inService
    dim outOfService
    dim dirbase
    dim dir
    dim switchfn
    dim where
    dim onOffSwitch
    dim nowDay
    dim nowHour
    dim nowMinutes
    dim fs
    dim fd
    dim result
    dim isSwitchedOff
    
sub setGlobals
    ' directory where announcements are stored
    inService = "inService"
    outOfService = "outOfService"
    dirbase = "music" 
    onOffSwitch = "switched-off"

    switchfn = Server.MapPath(onOffSwitch)
end sub
   
function getAnnouncementName(show)
   
    setGlobals   
   
    MyDate = Date
    MyTime = Time()
    nowDay = Weekday(MyDate)
    if Request.QueryString("day") <> "" then
       nowDay = Request.QueryString("day")
    end if
    nowHour = Hour(MyTime)
    if Request.QueryString("hours") <> "" then
       nowHour = Request.QueryString("hours")
    end if
    nowMinutes = Minute(MyTime)
    if Request.QueryString("minutes") <> "" then
       nowMinutes = Request.QueryString("minutes")
    end if

    ' global override?
    set fd = nothing
    err.Clear
    on error resume next
    set fs = server.CreateObject("Scripting.FileSystemObject")   
    set fd = fs.OpenTextFile(switchfn, 1, false)
    if err.number = 0 then
        isSwitchedOff = true
    else
        isSwitchedOff = false
        ts.close
    end if
    on error goto 0
    set fs = nothing

    ' the timing algorithm (change to your needs)
    if nowDay = 1 OR nowDay = 7 then
        where = outOfService
    elseif nowHour < 9 then
        where = outOfService
    elseif nowHour >= 18 OR (nowHour > 17 and nowMinutes > 29) then
        where = outOfService
    elseif isSwitchedOff then
        where = outOfService
    else
        where = inService
    end if
    ' end of timing algorithm
   
    ' construct announcement dir path
    dir = dirbase & "/" & where    
   
    result = Server.MapPath(dir & "/" & Request.QueryString("name"))
    getAnnouncementName = result
    if show = true then
        Response.Write("<title>innovaphone Ansagensteuerung - aktueller Status</title>&nbsp;<p>")
        Response.Write("<TABLE id=""Table1"" cellSpacing=""1"" cellPadding=""2"" width=""70%"" border=""0"">")
        Response.Write("<TR><TD>Wochentag:</TD><TD colspan=2>" & nowDay & "</TD></TR><TR><TD>Zeit</TD><TD>" & nowHour & ":" & nowMinutes & "</TD></TR>")
        Response.Write("<TR><TD>Aktueller Ansagestatus:</TD><TD colspan=2>" & where & "</TD></TR>")
        if isSwitchedOff then
            Response.Write("<TR><td></td><TD colspan=3>Dienst ist global abgestellt</TD></TR>")
        else
            Response.Write("<TR><td></td><TD colspan=3>Dienst ist zeitgesteuert</TD></TR>")
        end if
        Response.Write("<TR><TD>Ordner fr Ansagen:</TD><TD colspan=2>" & result & "</TD></TR>")
        Response.Write("</TABLE><p>")
        Response.Write("<a href=""play.htm"">Zeitsteuerung an/abstellen</a>")
    end if
end function

sub sendMusic(fn)
    Response.AddHeader "Content-type", "application/binary"
    Response.BinaryWrite CreateObject("Scripting.FileSystemObject").OpenTextFile(fn, 1, False, true).readall
end sub

sub doSwitch(inService)
    setGlobals
    err.Clear
    dim e, estr
    e = 4711
    estr = "dunno"
    on error resume next
    if not inService then
        Response.Write("create file")
        CreateObject("Scripting.FileSystemObject").OpenTextFile switchfn, 2, true
        e = err.number
        estr = err.Description
    else
        Response.Write("delete file")
        CreateObject("Scripting.FileSystemObject").DeleteFile switchfn, true
        e = err.number
        estr = err.Description
    end if
    on error goto 0
    Response.Write("doSwitch(" & inService & ", " & switchfn & "): " & e & " (" & estr & ")")
    Response.Redirect("announce.asp?action=show")
end sub

dim action 
action = Request.QueryString("action") 
if action = "show" then
    getAnnouncementName(true)
elseif action = "stop" then
    doSwitch false
elseif action = "start" then
    doSwitch true
elseif action = "" then
    sendMusic(getAnnouncementName(false))
else
    response.AddHeader "Status", "404"
    Response.Write("<strong>Invalid action '" & action & "'</strong>")
end if
%>
